        function []=plotSolution2D(obj,X_d,varargin)
              %plotSolution2D(x,points1,color1,points2,color2,...) plots the
              %DC centering problem for the parameter x. Moreover, the
              %points are plotted in the specified color.
              nrPoints=(nargin)/2-1;
                           

              %%%%%%%%%%%%%%%%%%%%%%%%%%
              % collect bounding boxes %
              %%%%%%%%%%%%%%%%%%%%%%%%%%


              [pt_min_Cont, pt_max_Cont] = obj.container.getBoundingBox();
              vy1_min1 = pt_min_Cont(1);
              vy2_min1 = pt_min_Cont(2);
              vy1_max1 = pt_max_Cont(1);
              vy2_max1 = pt_max_Cont(2);


              [pt_min_Des, pt_max_Des] = obj.design.getBoundingBox(X_d);
              vy1_min2 = pt_min_Des(1);
              vy2_min2 = pt_min_Des(2);
              vy1_max2 = pt_max_Des(1);
              vy2_max2 = pt_max_Des(2);



               y1_max = max(vy1_max1,vy1_max2);
               y1_min = min(vy1_min1,vy1_min2);
               y2_max = max(vy2_max1,vy2_max2);
               y2_min = min(vy2_min1,vy2_min2);
              
              y1Range = y1_max-y1_min+0.5;
              y2Range = y2_max-y2_min+0.6;

              width = 14;
              height = y2Range/y1Range*width;
              
              %initialize figure
              fh = fig('width', width, 'height', height);

              %%%%%%%%%%%%%%%%%%
              % plot container %
              %%%%%%%%%%%%%%%%%%

              try
              obj.container.plotContainer();
              catch me
                 warning('There is no routine "plotContainer"') 
              end
              %%%%%%%%%%%%%%%%
              % plot  design %
              %%%%%%%%%%%%%%%%

              try
              obj.design.plotDesign(X_d);
              catch me
                 warning('There is no routine "plotDesign"') 
              end

              %%%%%%%%%%%%%%%
              % plot points %
              %%%%%%%%%%%%%%%
              hold on
              for i=1:nrPoints
                  
                  Y=varargin{2*i-1};
                  color=varargin{2*i};
                  if size(Y,1)~=0
                    
                    scatter(Y(:,1),Y(:,2),'MarkerEdgeColor','black','MarkerFaceColor',color);
                  end          
              end
             
              
              
              
              
              %settings for the picture
              grid on;

              set(gca, 'DataAspectRatio', [1 1 1]);
              set(gca, 'Units', 'centimeters');
              xlim([y1_min-0.1, y1_max+0.1]);
              ylim([y2_min-0.1, y2_max+0.1]);

              xlabel('');
              ylabel('');
              title('');

              


            end


