function [ DxDxL] = DxDxLowLevLagrangeFun(obj,i,x,y,mu)

    %Returns the 2nd derivative with respect to x of  the largrange function 
    %for the i-th lower level problem. The first elements of mu correspond 
    %to the constraints u. The next to the linear constraint, then come the
    %upper bounds and the last elements belong to the lower bounds. 
    %The bounds which are inf or -inf are dropped.

    %objective Function for the i-th LowerLevelProblem
    DxDxL=obj.DxDxSemiInfConstrs(i,x,y);
    %For adding the constraints find the index of the IndexSet
    indexSet=obj.getIndexSetOfSemiInfConstr(i);
    DxDxu=obj.DxDxAllLowLevConstrs(indexSet,x,y);
    newSize=size(DxDxu);
    for j=1:obj.getNrAllLowLevConstrs(i)
        DxDxL=DxDxL-mu(j)*reshape(DxDxu(j,:,:),newSize(2:3));
    end
    %saves the number of already added constraints
%    ID=0;
%    %Add the non linear constraints
%     DxDxu=obj.DxDxLowLevNonlinConstrs(indexSet,x,y);
%     DxDxuAsMatrix=reshape(DxDxu,[obj.nrOfLowLevNonlinConstrs*obj.nrOfLowLevVars,obj.nrOfLowLevNonlinConstrs]);
%     %Vector for indices
%     indexVector=(0:(obj.nrOfUppLevVars-1))*obj.nrOfLowLevNonlinConstrs;
%     if obj.nrOfLowLevNonlinConstrs(indexSet)>0
%         for i=1:obj.nrOfLowLevNonlinConstrs
%             DxDxL=DxDxL-mu(i)*DxDxuAsMatrix(indexVector+i,:);
%         end    
%     end
%     
%     %Add the linear constraints    
%     [A,b]=obj.getLinIneqsOnLowLevVars(indexSet,x);
%     [DxDxA,DxDxb]=obj.DxDxLinIneqsOnLowLevVars(indexSet,x);
%     nrLinIneqs=size(A,1);
%     %Matrix for the indices (linear Indexing)
%     indexMatrixb=reshape((0:obj.nrOfUppLevVars^2-1)*nrLinIneqs,...
%         obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
%     indexMatrixA=reshape((0:obj.nrOfUppLevVars^2-1)*obj.nrOfLowLevVars*nrLinIneqs,...
%         obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
%     for i=1:nrLinIneqs
%         %use linear indexing
%         DxDxL=DxDxL+mu(ID+i)*DxDxb(indexMatrixb+i);
%         for j=1:obj.nrOfLowLevVars
%             %use linear indexing;
%             DxDxL=DxDxL-mu(ID+i)*DxDxA(indexMatrixA+(i-1)*obj.nrOfLowLevVars+j)*y(j);
%         end
%     end
%     
%     ID=ID+nrLinIneqs;
%     %Add the boundaries
%     %Matrix for the indices (linear Indexing)
%     indexMatrix=reshape((0:obj.nrOfUppLevVars^2-1)*obj.nrOfUppLevVars,...
%         obj.nrOfUppLevVars,obj.nrOfUppLevVars)';
%     [lb,ub]=obj.getBoundsOnLowLevVars(indexSet,x);
%     [DxDxlb,DxDxub]=obj.DxDxBoundsOnLowLevVars(indexSet,x);
%     constrlb=lb-y;
%     %drop the boundaries with -inf
%     IndicesConstrs=1:obj.nrOfLowLevVars;
%     constrlb=IndicesConstrs(constrlb~=-inf);
%     for i=constrlb
%         DxDxL=DxDxL-mu(ID+1)*DxDxlb(indexMatrix+i);
%         ID=ID+1;
%     end
% 
%     
%     construb=y-ub;
%     %drop the boundaries with -inf
%     IndicesConstrs=1:obj.nrOfLowLevVars;
%     construb=IndicesConstrs(construb~=-inf);
%     for i=construb
%         DxDxL=DxDxL-mu(ID+1)*DxDxub(indexMatrix+i);
%         ID=ID+1;
%     end
    

end

