function [ DyL ] = DyLowLevLagrangeFun(obj,i,x,y,mu)
    %Returns the derivative with respect to y of  the largrange function 
    %for the i-th lower level problem. The first elements of mu correspond 
    %to the constraints u. The next to the linear constraint, then come the
    %upper bounds and the last elements belong to the lower bounds. 
    %The bounds which are inf or -inf are dropped.

    %objective Function for the i-th LowerLevelProblem
    DyL=obj.DySemiInfConstrs(i,x,y);
    %For adding the constraints find the index of the IndexSet
    
    indexSet=obj.getIndexSetOfSemiInfConstr(i);
    DyL=DyL-mu*obj.DyAllLowLevConstrs(indexSet,x,y);
    
%     
%     %saves the number of already added constraints
%     ID=0;
%     %Add the non linear constraints
%     if obj.nrOfLowLevNonlinConstrs(indexSet)>0
%         DyL=DyL-mu(1:obj.nrOfLowLevNonlinConstrs(indexSet))*obj.DyLowLevNonlinConstrs(indexSet,x,y);
%         ID=ID+obj.nrOfLowLevNonlinConstrs(indexSet);
%     end
% 
%     %Add the linear constraints    
%     [A,b]=obj.getLinIneqsOnLowLevVars(indexSet,x);
%     nrLinIneqs=size(A,1);
%     DyL=DyL-mu(ID+1:ID+nrLinIneqs)*A;
%     ID=ID+nrLinIneqs;
%     %Add the boundaries
%     [lb,ub]=obj.getBoundsOnLowLevVars(indexSet,x);
%     constrlb=lb-y;
%     %drop the boundaries with -inf
%     constrlb=constrlb(constrlb~=-inf);
%     Dconstrlb=-eye(obj.nrOfLowLevVars);
%     Dconstrlb=Dconstrlb(constrlb~=-inf,:);
%     nrconstrlb=length(constrlb);
%     DyL=DyL-mu(ID+1:ID+nrconstrlb)*Dconstrlb;
%     ID=ID+nrconstrlb;
%     
%     construb=y-ub;
%     construb=construb(construb~=-inf);
%     Dconstrub=eye(obj.nrOfLowLevVars);
%     Dconstrub=Dconstrub(construb~=-inf,:);
%     nrconstrub=length(construb);
%     DyL=DyL-mu(ID+1:ID+nrconstrub)*Dconstrub;
    

end

