function [ g] = evalAllUppLevIneqConstrs(obj, x)
    %g=evalAllUppLevIneqConstrs(i,x,y) plugs the three different types of
    %upper level inequality constraints together. The first input is the 
    %index of the indexset, x are the upper level variables and y the lower
    %level variables.    
    %The first constraints are the non-linear constratins, the next are the
    %linear constraints and the last are the boundaries. First come the 
    %lower bounds and then the upper bounds. We delete all boundaries with
    %value + or - infinity.
    
%non linear
g1=obj.evalUppLevNonlinIneqConstrs(x);

%linear constraints
[A,b]=obj.getLinIneqsOnUppLevVars;
if size(A,2)>0
    g2=A*x'-b;
    g2=g2';
else
    g2=[];
end


%bounds

[lb,ub]=obj.getBoundsOnUppLevVars;

constrlb=lb-x;
%drop the boundaries with -inf
constrlb=constrlb(constrlb~=-inf);   
construb=x-ub;
construb=construb(construb~=-inf);

g=[g1,g2,constrlb,construb];

end

