function [h] = implicitPlotOfOptValueFunction1Variable(problem,i,IndexDraw,Bounds,ValsOthers,numberOfEvaluatedPoints)
%Please use the function implicitPlotOfOptValueFunction. This function does
%not check the correctness of inputs
yValues=zeros(numberOfEvaluatedPoints,size(i,2));
xValues=linspace(Bounds(1,1),Bounds(2,1),numberOfEvaluatedPoints);

%Settings for the solver
myLLPfminconOptions = optimset('Algorithm', 'sqp');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'Display', 'off');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'MaxFunEvals', Inf);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'MaxIter', 1000);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'FunValCheck', 'on');
%myLLPfminconOptions = optimset(myLLPfminconOptions, 'GradObj', 'on', 'GradConstr', 'on', 'DerivativeCheck', der_check);
myLLPfminconOptions = optimset(myLLPfminconOptions, 'ScaleProblem', 'obj-and-constr');
myLLPfminconOptions = optimset(myLLPfminconOptions, 'FinDiffType', 'central');

for j=1:numberOfEvaluatedPoints
    for j2=1:size(i,2)
        index=i(j2);    

        x_temp=[ValsOthers(1:IndexDraw-1),xValues(j),ValsOthers(IndexDraw:end)];
        %optimization of every lower level problem
        % get all the necessary information
        k=problem.getIndexSetOfSemiInfConstr(index);   
        Yint = problem.getInitValsLowLevVars(k,x_temp);
        [lbl, ubl] = problem.getBoundsOnLowLevVars(k,x_temp);
        [Aineq,bineq] = problem.getLinIneqsOnLowLevVars (k,x_temp);
        % max-problem    
        [~,fval] = fmincon(@LLPObjFun,Yint,Aineq,bineq,[],[],lbl,ubl,@LLPConFuns,myLLPfminconOptions,problem,index,x_temp,k);
        %save the optimal values
        yValues(j,j2)=-fval;
        if mod(j,10)==0 && j2==size(i,2)
           fprintf('The first %i points are computed\n',j);
        end
    end
end
%compute the maximum of the yvalues
yValues=max(yValues,[],2);
figure;    
h=plot(xValues,yValues,'-b');
xlabel('Parameter ');
ylabel('Values of the optimal value function');
title('optimal value function')


    
    
    
    
    
    
%objective function of the lower level
function [g, grad_g_y] = LLPObjFun(y,GSIP_problem2,i,xval,~)
   
    g_temp = GSIP_problem2.evalSemiInfConstrs(i,xval,y);
    g=-g_temp; %max-problem
    
    
    grad_g_y_temp = GSIP_problem2.DySemiInfConstrs(i,xval,y);
    grad_g_y=-grad_g_y_temp';
end

%constraints of the lower level problem
function [u, h, grad_u, grad_h] = LLPConFuns(y,GSIP_problem2,~,xval,k2)
      
    h = [];
    grad_h = [];
    assert(size(y,1)==1);
    u = GSIP_problem2.evalLowLevNonlinConstrs(k2,xval,y);
    
    grad_u = GSIP_problem2.DyLowLevNonlinConstrs(k2,xval,y)';

end
    

end

